﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace drawaline
{
    public partial class Form1 : Form
    {
        int x1, x2, y1, y2;

        bool flag = false;
       
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var _with1 = fpSpread1.Sheets[0];

            _with1.Rows.Count = 11;
            _with1.Columns.Count = 4;
            _with1.Columns[0].Visible = false;

            _with1.SetValue(0, 1, "●");
            _with1.SetValue(1, 1, 1);
            _with1.SetValue(2, 1, 2);
            _with1.SetValue(3, 1, 3);
            _with1.SetValue(4, 1, 4);
            _with1.SetValue(5, 1, "●");
            _with1.SetValue(6, 1, "●");
            _with1.SetValue(7, 1, "●");
            _with1.SetValue(8, 1, 1);
            _with1.SetValue(9, 1, "●");
            _with1.SetValue(10, 1, 1);


            _with1.SetValue(0, 2, 1);
            _with1.SetValue(1, 2, "●");
            _with1.SetValue(2, 2, 1);
            _with1.SetValue(3, 2, 2);
            _with1.SetValue(4, 2, "●");
            _with1.SetValue(5, 2, 1);
            _with1.SetValue(6, 2, 2);
            _with1.SetValue(7, 2, 3);
            _with1.SetValue(8, 2, 4);
            _with1.SetValue(9, 2, 5);
            _with1.SetValue(10, 2, "●");

            _with1.SetValue(0, 3, 1);
            _with1.SetValue(1, 3, 2);
            _with1.SetValue(2, 3, "●");
            _with1.SetValue(3, 3, "●");
            _with1.SetValue(4, 3, 1);
            _with1.SetValue(5, 3, 2);
            _with1.SetValue(6, 3, 3);
            _with1.SetValue(7, 3, 4);
            _with1.SetValue(8, 3, "●");
            _with1.SetValue(9, 3, 1);
            _with1.SetValue(10, 3, 2);

            for (int j = 0; j <= 3; j++)
            {
                _with1.Columns[j].Width = 30;
                _with1.Columns[j].Locked = true;
                //锁定单元格
                _with1.Columns[j].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
                _with1.Columns[j].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            }


            for (int i = 0; i <= 10; i++)
            {
                _with1.Rows[i].Height = 30;


            }
            fpSpread1.Paint += new PaintEventHandler(fpSpread1_Paint);


        }

        void fpSpread1_Paint(object sender, PaintEventArgs e)
        {
            for (int r = 0; r < fpSpread1.Sheets[0].RowCount; r++)
                for (int c = 1; c < fpSpread1.Sheets[0].ColumnCount; c++)
                {
                    if (fpSpread1.Sheets[0].Cells[r, c].Value.Equals("●"))
                    {
                        if (r == 0)
                        {
                            x1 = fpSpread1.GetCellRectangle(0, 0, r, c).X + 11;
                            y1 = fpSpread1.GetCellRectangle(0, 0, r, c).Y + 11;
                            flag = false;
                        }
                        else if (x2 != 0 && y2 != 0)
                        {
                            x1 = x2;
                            y1 = y2;
                            flag = false;
                        }
                    }
                    if (fpSpread1.Sheets[0].Cells[r, c].Value.Equals("●") && r != 0)
                    {
                        x2 = fpSpread1.GetCellRectangle(0, 0, r, c).X + 11;
                        y2 = fpSpread1.GetCellRectangle(0, 0, r, c).Y + 11;
                        flag = true;
                    }
                    else
                        flag = false;
                    if (flag == true)
                    {
                        System.Drawing.Pen myPen;
                        myPen = new System.Drawing.Pen(System.Drawing.Color.Red);
                        e.Graphics.DrawLine(myPen, x1, y1, x2, y2);
                        if (r == fpSpread1.Sheets[0].RowCount - 1)
                        {
                            x2 = 0;
                            y2 = 0;
                        }
                    }
              }
            

        }
    }
}
   

